> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a new app

> Creates a new app entry in the system.

Requires an `nx1_app_manager` role.



## OpenAPI

````yaml post /api/app
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/app:
    post:
      tags:
        - App manager
      summary: Create a new app
      description: |-
        Creates a new app entry in the system.

        Requires an `nx1_app_manager` role.
      operationId: create_app_api_app_post
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateAppRequest'
      responses:
        '200':
          description: App created successfully.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateAppResponse'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: Unauthorized
        '403':
          description: Forbidden - Requires an `nx1_app_manager` role.
        '409':
          description: App already exists.
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    CreateAppRequest:
      properties:
        app_name:
          type: string
          title: App Name
          description: >-
            Unique name of the app. It must contain only alphanumeric
            characters, `-`, or `_`, and no spaces.
        app_type:
          $ref: '#/components/schemas/AppTypeEnum'
          description: Type of application.
          default: hand_authored
      type: object
      required:
        - app_name
      title: CreateAppRequest
      description: |-
        Request model for creating a new App.
        App name must be filesystem + S3 safe.
    CreateAppResponse:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          description: Unique ID of the created app.
        app_name:
          type: string
          title: App Name
          description: Name of the created app.
        app_type:
          $ref: '#/components/schemas/AppTypeEnum'
          description: Type of application.
          default: hand_authored
        created_by:
          anyOf:
            - type: string
            - type: 'null'
          title: Created By
          description: Username of the creator.
        created_date:
          title: Created Date
          description: Timestamp when the app was created.
      type: object
      required:
        - id
        - app_name
        - created_date
      title: CreateAppResponse
      description: Response model for creating a new App.
    ErrorResponse:
      properties:
        error:
          type: string
          title: Error
          description: A brief description of the error that occurred.
        code:
          type: integer
          title: Code
          description: The HTTP status code associated with the error.
          default: 500
      type: object
      required:
        - error
      title: ErrorResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    AppTypeEnum:
      type: string
      enum:
        - hand_authored
        - notebook_pipeline
        - inference_service
        - full_pipeline
      title: AppTypeEnum
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````